
YarkoMods = {};

YARKOMODS_ADDONNAME = "YarkoMods";

YarkoMods_SavedVars = {};

YarkoMods.isRetail = (WOW_PROJECT_ID == WOW_PROJECT_MAINLINE);

local repBarText = "%s - %s";
local repBarTextFull = "%s: %s / %s (%d%%, %s remaining), %s";
local xpBarText = "XP: %s / %s (%d%%, %s remaining), Level: %d";
local naText = "N/A";
local oldExhaustionToolTipText;
local oldUpdateCurrentText;
local oldFontObject;
local oldFontXY;

local timeSinceLastLocUpdate = 0;
local timeSinceLastMapLocUpdate = 0;

local soundsDir = "Interface\\AddOns\\YarkoMods\\Sounds\\";

local addonAlarmPlayed = false;

local lineAdded = false;

local graysList = {};
local maxSlots;
local curGrayDel
local curBagId;
local curSlot;
local delCounter;
local selling;
local sellTotal;
local sellTimer;

local shellSlot;
local shellOpening;
local shellTime;
local shellQueue = {};
local shellRunning;
local shellList = {
	["Thick-shelled Clam"] = true,
	["Small Barnacled Clam"] = true,
	["Big-mouth Clam"] = true,
	["Soft-shelled Clam"] = true,
	["Darkwater Clam"] = true,
	["Jaggal Clam"] = true,
	["Abyssal Clam"] = true,
	["Brooding Darkwater Clam"] = true,
	["Giant Darkwater Clam"] = true,
};

-- globals made local in ContainerFrame.lua
local BACKPACK_BASE_SIZE = 16;
local NUM_CONTAINER_COLUMNS = 4;
local BACKPACK_EXTENDED_TOPHEIGHT = 226;
local BACKPACK_DEFAULT_TOPHEIGHT = 256;
local BACKPACK_MONEY_OFFSET_DEFAULT = (YarkoMods.isRetail and -231) or -215;
local BACKPACK_MONEY_HEIGHT_OFFSET_PER_EXTRA_ROW = 41;

local retailBackpackExtraHeight = 35;
local classicBackpackExtraHeight1 = 15;
local classicBackpackExtraHeight2 = 23;
local classicBackpackExtraHeight3 = 50;
local classicBackpackTopHeight = 48;
local backpackExtraHeight;
local origBackpackBaseHeight = BACKPACK_BASE_HEIGHT;
local origFirstBackpackButtonOffsetBase = FIRST_BACKPACK_BUTTON_OFFSET_BASE;

local origChatFrameOnEvent;

BINDING_HEADER_YARKOMODS = "YarkoMods";
BINDING_NAME_INCREASEGAMMA = "Increase Gamma";
BINDING_NAME_DECREASEGAMMA = "Decrease Gamma";

StaticPopupDialogs["YARKOMODS_DELETEGRAYSCHOICE"] = {
	text = "Destroy the gray items in how many bag slots?",
	button1 = ACCEPT,
	button2 = CANCEL,
	OnAccept = function()
		local arg = "all";
		
		if (YarkoMods_DeleteGraysFrameRadioButton1:GetChecked()) then
			arg = YarkoMods_DeleteGraysFrameInputBox:GetText();
		end
		
		YarkoMods.DeleteGrays(arg);
	end,
	timeout = 0,
	--showAlert = 1,
	exclusive = 1,
	hideOnEscape = 1
};

StaticPopupDialogs["YARKOMODS_DELETEGRAYS"] = {
	text = "Delete all gray items from all bags?",
	button1 = ACCEPT,
	button2 = CANCEL,
	OnAccept = function()
		YarkoMods.StartDeleteGrays();
	end,
	timeout = 0,
	showAlert = 1,
	exclusive = 1,
	hideOnEscape = 1
};

StaticPopupDialogs["YARKOMODS_SELLGRAYS"] = {
	text = "Sell all gray items from all bags?",
	button1 = ACCEPT,
	button2 = CANCEL,
	OnAccept = function()
		YarkoMods.StartSellGrays();
	end,
	timeout = 0,
	showAlert = 1,
	exclusive = 1,
	hideOnEscape = 1
};

function YarkoMods.OnLoad(self)
	-- Print version
	SlashCmdList["VERSION"] = YarkoMods.Version;
	SLASH_VERSION1 = "/version";
	SLASH_VERSION2 = "/ver";

	SlashCmdList["DELETEGRAYS"] = YarkoMods.DeleteGrays;
	SLASH_DELETEGRAYS1 = "/deletegrays";

	SlashCmdList["CLEARACTIONBARS"] = YarkoMods.ClearActionBars;
	SLASH_CLEARACTIONBARS1 = "/clearactionbars";

	SlashCmdList["WHO"] = function(msg)
		if (YarkoMods.isRetail and IsKioskModeEnabled()) or (not YarkoMods.isRetail and Kiosk.IsEnabled()) then
			return;
		end
		if ( msg == "" ) then
			msg = 'z-"'..GetZoneText()..'"';
			ShowWhoPanel();
		end
		WhoFrameEditBox:SetText(msg);
		C_FriendList.SendWho(msg);
	end
	
	SlashCmdList["YARKOMODSRL"] = function()
		ConsoleExec("reloadui");
	end
	SLASH_YARKOMODSRL1 = "/rl";
	
	self:RegisterEvent("PLAYER_LOGIN");
	
	-- Nowadays, blizzard sets up status bars after PLAYER_ENTERING_WORLD
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	
	-- Register events to play block sound
	self:RegisterEvent("MACRO_ACTION_FORBIDDEN");
	self:RegisterEvent("ADDON_ACTION_FORBIDDEN");
	
	-- Tradeskill tooltip detail
	self:RegisterEvent("ADDON_LOADED");
	
	-- Open clams
	if (not YarkoMods.isRetail) then
		self:RegisterEvent("BAG_UPDATE");
	end
	
	-- block chat channel invite text
	origChatFrameOnEvent = ChatFrame_OnEvent;
	ChatFrame_OnEvent = YarkoMods.ChatFrameOnEvent;
end

function YarkoMods.OnEvent(self, event, ...)
	local arg1 = ...;
	
	if ( event == "PLAYER_LOGIN" ) then
		YarkoMods.SetupOptions();
		
		-- Locate map location text
		YarkoMods_MapLocFrame:SetParent(WorldMapFrame.ScrollContainer);
		YarkoMods_MapLocFrame:SetPoint("BOTTOM", 0, 8);
		YarkoMods_MapLocFrame.Background:SetVertexColor(.19, .16, .14);
		
		if (YarkoMods.isRetail) then
			-- vehicle stuff
			hooksecurefunc("PlayerFrame_ToVehicleArt", function() if (YarkoMods_SavedVars.Resting == "Y") then YarkoMods.PlayerFrameToVehicleArt() end end);
			hooksecurefunc("PlayerFrame_ToPlayerArt", YarkoMods.PlayerFrameToPlayerArt);
		end
		
		-- Show in combat on top of resting
		hooksecurefunc("PlayerFrame_UpdateStatus", YarkoMods.PlayerFrameUpdateStatus);
		
		-- Fix bug where player is pet of vehicle and pet tries to attack
		PetFrame:HookScript("OnEvent", function(self, event, ...)
			if (event == "PET_ATTACK_START" and (not PetCanBeAbandoned() or UnitIsDead("pet"))) then
				PetAttackModeTexture:Hide();
			end
		end);
		
		-- Darken level background
		if (YarkoMods.isRetail) then
			PlayerFrameTexture:SetTexture("Interface\\AddOns\\YarkoMods\\Textures\\TargetingFrame.tga");
		else
			PlayerFrameTexture:SetTexture("Interface\\AddOns\\YarkoMods\\Textures\\TargetingFrame-classic.tga");
		end
		
		-- Hooks for adding grays buttons and search
		hooksecurefunc("ContainerFrame_GenerateFrame", YarkoMods.UpdateBackpackTexture);
		hooksecurefunc("ContainerFrame_Update", YarkoMods.ContainerFrameUpdate);
		
		if (YarkoMods.isRetail) then
			hooksecurefunc("ManageBackpackTokenFrame", YarkoMods.ManageBackpackTokenFrame);
		end
		
		-- Sell grays button enable
		hooksecurefunc("ContainerFrame_Update", YarkoMods.SellGraysButtonUpdate);
		hooksecurefunc("MerchantFrame_Update", YarkoMods.SellGraysButtonUpdate);
		MerchantFrame:HookScript("OnHide", YarkoMods.SellGraysButtonUpdate);
		
		-- Minimap mouse wheel
		Minimap:SetScript("OnMouseWheel", YarkoMods.MinimapOnMouseWheel);
		
		-- Move minimap zoomin button
		if (YarkoMods.isRetail) then
			MinimapZoomIn:SetPoint("CENTER", 70, -25);
		else
			MinimapZoomIn:SetPoint("CENTER", 72, -22);
		end

	-- Date info in calendar button tooltip
		if (YarkoMods.isRetail) then
			hooksecurefunc("GameTimeFrame_OnUpdate", YarkoMods.CalendarTooltip);
			GameTimeFrame:HookScript("OnUpdate", YarkoMods.CalendarTooltip);
		else
			TimeManagerClockButton_UpdateTooltip = YarkoMods.TimeTooltip;
		end
		
		-- Open bank bags when opening bank
		BankFrame:HookScript("OnShow", YarkoMods.OpenBankBags);
		
		-- Sort guild list by level
		if (not YarkoMods.isRetail and YarkoMods_SavedVars.Roster == "Y") then
			-- Twice for descending order
			SortGuildRoster("level");
			SortGuildRoster("level");
		end
		
		if (not YarkoMods.isRetail) then
			YarkoMods.StartOpenClams(0);
		end
		
		if (IsAddOnLoaded("Auctionator") and YarkoMods_SavedVars.Auction == "Y") then
			-- Default auction length to longest possible
			hooksecurefunc("Atr_AddMainPanel", function() UIDropDownMenu_SetSelectedValue(Atr_Duration, 3) end);
		end
	end
	
	if ( event == "PLAYER_ENTERING_WORLD") then
		oldFontXY = {};

		if (YarkoMods.isRetail) then
			-- Show reputation rating name on reputation bar
			if (StatusTrackingBarManager.bars[1]) then -- Dominos destroys the standard bars I guess?
				hooksecurefunc(StatusTrackingBarManager.bars[1], "Update", YarkoMods.ReputationbarUpdate);
				hooksecurefunc(StatusTrackingBarManager.bars[1], "UpdateCurrentText", YarkoMods.ReputationbarUpdate);
			end
			
			if (StatusTrackingBarManager.bars[4]) then
				-- Show percent in exp bar
				hooksecurefunc(StatusTrackingBarManager.bars[4], "UpdateCurrentText", YarkoMods.ExpBarUpdateCurrentText);
				oldExhaustionToolTipText= StatusTrackingBarManager.bars[4].ExhaustionTick.ExhaustionToolTipText;
				
				-- Fix exhaustion tick strata
				--StatusTrackingBarManager.bars[4].ExhaustionTick:SetFrameStrata("MEDIUM");
			end
			
			oldFontObject = StatusTrackingBarManager.bars[1].OverlayFrame.Text:GetFontObject();
			
			for i = 1, #(StatusTrackingBarManager.bars) do
				oldFontXY[i] = {};
				_, _, _, oldFontXY[i].x, oldFontXY[i].y 
					= StatusTrackingBarManager.bars[i].OverlayFrame.Text:GetPoint(1);
			end
			
			local index = #(StatusTrackingBarManager.bars) + 1;
			oldFontXY[index] = {};
			_, _, _, oldFontXY[index].x, oldFontXY[index].y = OverrideActionBarExpBarOverlayFrameText:GetPoint(1);
			oldFontXY[index + 1] = {};
			_, _, _, oldFontXY[index + 1].x, oldFontXY[index + 1].y = PetBattleFrameXPBar.TextString:GetPoint(1);
		else
			hooksecurefunc("MainMenuBar_UpdateExperienceBars", function() YarkoMods.ReputationbarUpdate(ReputationWatchBar) end);
			oldUpdateCurrentText = MainMenuExpBar.UpdateCurrentText;
			oldFontObject = MainMenuBarExpText:GetFontObject();
			_, _, _, oldFontXY.x, oldFontXY.y = MainMenuBarExpText:GetPoint(1);
		end
		
		-- Show percent in exp bar
		hooksecurefunc("TextStatusBar_UpdateTextStringWithValues", YarkoMods.UpdateTextStringWithValues);
		
		YarkoMods.UpdateExpBars();
		
		YarkoMods.initialized = true;
		
		self:UnregisterEvent("PLAYER_ENTERING_WORLD");
	end
	
	if ( event == "ADDON_LOADED" ) then
		-- More tradeskill reagent detail
		if (arg1 == "Blizzard_TradeSkillUI") then
			if (YarkoMods.isRetail) then
				hooksecurefunc(TradeSkillFrame.DetailsFrame, "RefreshDisplay", function(self) YarkoMods.TradeSkillDetailUpdate(self.selectedRecipeID) end);
				hooksecurefunc(TradeSkillFrame.DetailsFrame, "OnReagentMouseEnter", function(self, button) YarkoMods.TradeSkillDetailTooltip(button) end);
			else
				hooksecurefunc("TradeSkillFrame_SetSelection", YarkoMods.TradeSkillDetailUpdate);
				
				for i = 1, 8 do
					_G["TradeSkillReagent"..i]:HookScript("OnEnter", YarkoMods.TradeSkillDetailTooltip);
					_G["TradeSkillReagent"..i].UpdateTooltip = _G["TradeSkillReagent"..i]:GetScript("OnEnter");
				end
				
				-- Better item count
				hooksecurefunc("TradeSkillFrame_SetSelection", YarkoMods.TradeSkillSetSelection);
			end
		end
		
		if (arg1 == "Blizzard_CraftUI") then
			hooksecurefunc("CraftFrame_SetSelection", function(id) YarkoMods.TradeSkillDetailUpdate(id, true) end);
			
			for i = 1, 8 do
				_G["CraftReagent"..i]:HookScript("OnEnter", YarkoMods.TradeSkillDetailTooltip);
				_G["CraftReagent"..i].UpdateTooltip = _G["CraftReagent"..i]:GetScript("OnEnter");
			end
		end
		
		if (arg1 == "Blizzard_AuctionUI" and YarkoMods_SavedVars.Auction == "Y") then
			-- Default auction length to longest possible
			if (YarkoMods.isRetail) then
				AuctionFrameAuctions.duration = 3;
			else
				AuctionsRadioButton_OnClick(3);
			end
		end
	end
	
	-- Combat sounds
	if (event == "PLAYER_REGEN_DISABLED") then
		YarkoMods.PlaySound("Combaton");
		
		return;
	end

	if (event == "PLAYER_REGEN_ENABLED") then
		YarkoMods.PlaySound("Combatoff");
		
		return;
	end
	
	-- Action blocked sound
	if (event == "MACRO_ACTION_FORBIDDEN" or event == "ADDON_ACTION_FORBIDDEN") then
		YarkoMods.PlaySound("Alarm");
		
		return;
	end
	
	if (event == "BAG_UPDATE") then
		YarkoMods.StartOpenClams(arg1);
	end
end

function YarkoMods.GetPlayerLoc(decimal)
	local mapID = C_Map.GetBestMapForUnit("player");
	
	if (mapID == nil) then
		return naText;
	end
	
	local mapPos = C_Map.GetPlayerMapPosition(mapID, "player");
	
	if (mapPos == nil) then
		return naText;
	end
	
	local posX, posY = mapPos:GetXY();
	--posX, posY = 0.5555, 0.5555;
	
	if (posX >= 0 and posY >= 0) then
		if (decimal) then
			return format("%.2f, %.2f", posX * 100.0, posY * 100.0);
		else
			return format("%.1f, %.1f", posX * 100.0, posY * 100.0);
		end
	else
		return naText;
	end
end

function YarkoMods.PlayerLocUpdate(self, elapsed)
	timeSinceLastLocUpdate = timeSinceLastLocUpdate + elapsed;
	
	if (timeSinceLastLocUpdate > .1) then
		local playerLoc = YarkoMods.GetPlayerLoc();
		
		YarkoMods_PlayerLocText:SetText(playerLoc);
		
		timeSinceLastLocUpdate = 0;
	end
end

function YarkoMods.MapLocUpdate(self, elapsed)
	timeSinceLastMapLocUpdate = timeSinceLastMapLocUpdate + elapsed;
	
	if (timeSinceLastMapLocUpdate > .1 and YarkoMods_MapLocFrame:IsVisible()) then
		local mouseLoc = naText;
		local playerLoc = YarkoMods.GetPlayerLoc(true);
		
		if (playerLoc ~= naText) then
			local mapContainer = WorldMapFrame.ScrollContainer;
			local mapChild = WorldMapFrame.ScrollContainer.Child;
			
			local x, y = GetCursorPosition();
			local scale = mapContainer:GetEffectiveScale();

			x = x / scale;
			y = UIParent:GetHeight() - y / scale;
			
			local mapScale = mapContainer:GetCanvasScale();
			
			local viewWidth = mapContainer:GetWidth();
			local viewHeight = mapContainer:GetHeight();
			
			local mapWidth = mapChild:GetWidth() * mapScale;
			local mapHeight = mapChild:GetHeight() * mapScale;
			local centerX, centerY = mapContainer:GetCenter();
			local mapLeft = centerX - mapWidth * mapContainer:GetCurrentScrollX();
			local mapTop = UIParent:GetHeight() - centerY - mapHeight * mapContainer:GetCurrentScrollY();
			
			local adjustedX = (x - mapLeft) / mapWidth;
			local adjustedY = (y - mapTop) / mapHeight;
			--adjustedX, adjustedY = 9.9999, 9.9999;

			if (x >= centerX - viewWidth / 2 and x <= centerX + viewWidth / 2 and y >= UIParent:GetHeight() - centerY - viewHeight / 2 
					and y <= UIParent:GetHeight() - centerY + viewHeight / 2) then
				mouseLoc = format("%.2f, %.2f", adjustedX * 100.0, adjustedY * 100.0);
			else
				mouseLoc = naText;
			end
		end
		
		YarkoMods_MapLocText:SetText("Player: "..HIGHLIGHT_FONT_COLOR_CODE..playerLoc);
		YarkoMods_MouseLocText:SetText("Cursor: "..HIGHLIGHT_FONT_COLOR_CODE..mouseLoc);

		timeSinceLastMapLocUpdate = 0;
	end
end

function YarkoMods.PlayerLocShowTooltip(self)
	GameTooltip:SetOwner(self, "ANCHOR_BOTTOM", 50, 0);
	GameTooltip:AddLine("Player Location");
	GameTooltip:AddLine("|cffffffffShift + left-click and");
	GameTooltip:AddLine("|cffffffffdrag to move");
	GameTooltip:Show();
end

-- Show extra info on rep bar
function YarkoMods.ReputationbarUpdate(self)
	if (YarkoMods_SavedVars.BarInfo ~= "Y") then
		return;
	end
	
	local name, reaction, minBar, maxBar, value, factionID = GetWatchedFactionInfo();
	local isCapped;
	local friendshipID;
	local repText;
	
	if (YarkoMods.isRetail) then
		friendshipID = GetFriendshipReputation(factionID);
	end
	
	if (not (name or friendshipID)) then
		return;
	end
	
	-- do something different for friendships
	local level;
	
	repText = GetText("FACTION_STANDING_LABEL" .. reaction, UnitSex("player"));
	
	if ( friendshipID ) then
		local friendID, friendRep, friendMaxRep, friendName, friendText, friendTexture, friendTextLevel, friendThreshold, nextFriendThreshold = GetFriendshipReputation(factionID);
		repText = friendTextLevel;
		level = GetFriendshipReputationRanks(factionID);
		if ( nextFriendThreshold ) then
			minBar, maxBar, value = friendThreshold, nextFriendThreshold, friendRep;
		else
			-- max rank, make it look like a full bar
			minBar, maxBar, value = 0, 1, 1;
			isCapped = true;
		end
		
	elseif ( YarkoMods.isRetail and C_Reputation.IsFactionParagon(factionID) ) then
		local currentValue, threshold, _, hasRewardPending = C_Reputation.GetFactionParagonInfo(factionID);
		minBar, maxBar  = 0, threshold;
		value = currentValue % threshold;
		if ( hasRewardPending ) then 
			value = value + threshold;
		end
	else
		if ( reaction == MAX_REPUTATION_REACTION ) then
			isCapped = true;
		end
	end
	
	-- Normalize values
	maxBar = maxBar - minBar;
	value = value - minBar;
	if ( isCapped and maxBar == 0 ) then
		maxBar = 1;
		value = 1;
	end
	minBar = 0;
	
	if ( isCapped ) then
		text = repBarText:format(name, repText);
	else
		text = repBarTextFull:format(name, YarkoMods.CommaNumber(value), YarkoMods.CommaNumber(maxBar), floor(value/maxBar*100),
			YarkoMods.CommaNumber(maxBar-value), repText);
	end
	
	self.OverlayFrame.Text:SetText(text);
end

-- Show percentage on exp bar
function YarkoMods.ExpBarUpdateCurrentText(self)
	if (YarkoMods_SavedVars.BarInfo ~= "Y") then
		return;
	end
	
	local currXP = self.currXP;
	local maxBar = self.maxBar;
	self:SetBarText(YarkoMods.PlayerExpTextString(currXP, maxBar, UnitLevel("player"))); 
end

function YarkoMods.UpdateTextStringWithValues(statusFrame, textString, value, valueMin, valueMax)
	if (YarkoMods_SavedVars.BarInfo ~= "Y") then
		return;
	end
	
	local bar = ((statusFrame:GetName() == "MainMenuExpBar" or statusFrame:GetName() == "OverrideActionBarExpBar") and 1) 
		or (statusFrame:GetName() == "PetBattleFrameXPBar" and 2);
	
	if (bar and ( tonumber(valueMax) ~= valueMax or valueMax > 0 ) ) then
		textString:SetText((bar == 1 and YarkoMods.PlayerExpTextString(value, valueMax, UnitLevel("player"))) 
			or YarkoMods.ExpTextString(value, valueMax, C_PetBattles.GetLevel(LE_BATTLE_PET_ALLY, C_PetBattles.GetActivePet(LE_BATTLE_PET_ALLY))));
	end
end

function YarkoMods.ExpTextString(currXP, maxBar, level)
	return (xpBarText:format(YarkoMods.CommaNumber(currXP), YarkoMods.CommaNumber(maxBar), floor(currXP/maxBar*100), YarkoMods.CommaNumber(maxBar-currXP), level));
end

function YarkoMods.PlayerExpTextString(currXP, maxBar, level)
	if (GameLimitedMode_IsActive()) then
		local rLevel = GetRestrictedAccountData();
		if (level >= rLevel) then
			currXP = UnitTrialXP("player");
		end
	end
	return YarkoMods.ExpTextString(currXP, maxBar, level);
end

function YarkoMods.ExhaustionToolTipText()
	GameTooltip_SetDefaultAnchor(GameTooltip, UIParent);

	local exhaustionStateID, exhaustionStateName, exhaustionStateMultiplier = GetRestState();
	local exhaustionCurrXP, exhaustionMaxXP;
	local exhaustionThreshold = GetXPExhaustion();
	local exhaustionCountdown = nil;
	
	exhaustionStateMultiplier = exhaustionStateMultiplier * 100;
	
	if ( GetTimeToWellRested() ) then
		exhaustionCountdown = GetTimeToWellRested() / 60;
	end
	
	local currXP = UnitXP("player");
	local nextXP = UnitXPMax("player");
	local percentXP = math.floor(currXP/nextXP*100);
	local XPText = format( XP_TEXT, YarkoMods.CommaNumber(currXP), YarkoMods.CommaNumber(nextXP), percentXP );
	local tooltipText = LEVEL.." "..UnitLevel("player").."\n"..XPText..format(EXHAUST_TOOLTIP1, exhaustionStateName, exhaustionStateMultiplier);
	local append = nil;
	
	if ( IsResting() ) then
		if ( exhaustionThreshold and exhaustionCountdown ) then
			append = format(EXHAUST_TOOLTIP4, exhaustionCountdown);
		end
	elseif ( (exhaustionStateID == 4) or (exhaustionStateID == 5) ) then
		append = EXHAUST_TOOLTIP2;
	end

	if ( append ) then
		tooltipText = tooltipText..append;
	end

	if ( SHOW_NEWBIE_TIPS ~= "1" ) then
		GameTooltip:SetText(tooltipText);
	else
		if ( GameTooltip.canAddRestStateLine ) then
			GameTooltip:AddLine("\n"..tooltipText);
			GameTooltip:Show();
			GameTooltip.canAddRestStateLine = nil;
		end
	end
end

function YarkoMods.UpdateExpBars()
	if (YarkoMods_SavedVars.BarInfo == "Y") then
		if (YarkoMods.isRetail) then
			if (StatusTrackingBarManager.bars[4]) then
				-- Show level in experience bar tooltip
				StatusTrackingBarManager.bars[4].ExhaustionTick.ExhaustionToolTipText = YarkoMods.ExhaustionToolTipText;
				StatusTrackingBarManager.bars[4].ExhaustionTick:SetScript("OnEnter", YarkoMods.ExhaustionToolTipText);
				
				-- Fix exhaustion tick strata
				--StatusTrackingBarManager.bars[4].ExhaustionTick:SetFrameStrata("MEDIUM");
			end
			
			-- Make text bigger on exp bars
			for i = 1, #(StatusTrackingBarManager.bars) do
				StatusTrackingBarManager.bars[i].OverlayFrame.Text:SetFontObject(YarkoMods_ExpBarFont);
				StatusTrackingBarManager.bars[i].OverlayFrame.Text:SetPoint("CENTER", StatusTrackingBarManager.bars[i].StatusBar, "CENTER", 0, (i == 4 and 2) or 1);
			end
			
			OverrideActionBarExpBarOverlayFrameText:SetFontObject(YarkoMods_ExpBarFont);
			OverrideActionBarExpBarOverlayFrameText:SetPoint("CENTER", 0, 3);
			PetBattleFrameXPBar.TextString:SetFontObject(YarkoMods_ExpBarFont);
			PetBattleFrameXPBar.TextString:SetPoint("CENTER", 0, 3);
		else
			-- Show reputation rating name on reputation bar
			YarkoMods.ReputationbarUpdate(ReputationWatchBar);
			
			-- Show percent in exp bar
			MainMenuExpBar.UpdateCurrentText = YarkoMods.ExpBarUpdateCurrentText;
			
			-- Make text bigger on exp bars
			MainMenuBarExpText:SetFontObject(YarkoMods_ExpBarFont);
			MainMenuBarExpText:SetPoint("CENTER", "MainMenuExpBar", 0, 1);
			ReputationWatchBar.OverlayFrame.Text:SetFontObject(YarkoMods_ExpBarFont);
		end
	else
		-- reset to default settings
		if (YarkoMods.isRetail) then
			if (StatusTrackingBarManager.bars[4]) then
					StatusTrackingBarManager.bars[4].ExhaustionTick.ExhaustionToolTipText = oldExhaustionToolTipText;
				StatusTrackingBarManager.bars[4].ExhaustionTick:SetScript("OnEnter", oldExhaustionToolTipText);
			end
			
			for i = 1, #(StatusTrackingBarManager.bars) do
				StatusTrackingBarManager.bars[i].OverlayFrame.Text:SetFontObject(oldFontObject);
				StatusTrackingBarManager.bars[i].OverlayFrame.Text:SetPoint("CENTER", StatusTrackingBarManager.bars[i].StatusBar, "CENTER", oldFontXY[i].x, oldFontXY[i].y);
			end
			
			local index = #(StatusTrackingBarManager.bars) + 1;
			OverrideActionBarExpBarOverlayFrameText:SetFontObject(oldFontObject);
			OverrideActionBarExpBarOverlayFrameText:SetPoint("CENTER", oldFontXY[index].x, oldFontXY[index].y);
			PetBattleFrameXPBar.TextString:SetFontObject(oldFontObject);
			PetBattleFrameXPBar.TextString:SetPoint("CENTER", oldFontXY[index + 1].x, oldFontXY[index + 1].y);
		else
			MainMenuExpBar.UpdateCurrentText = oldUpdateCurrentText;

			MainMenuBar_UpdateExperienceBars();
			
			MainMenuBarExpText:SetFontObject(oldFontObject);
			MainMenuBarExpText:SetPoint("CENTER", "MainMenuExpBar", oldFontXY.x, oldFontXY.y);
			ReputationWatchBar.OverlayFrame.Text:SetFontObject(oldFontObject);
		end
	end
end

-- Show combat icon over resting icon
function YarkoMods.PlayerFrameUpdateStatus()
--[[	print("here");
	if ( UnitHasVehiclePlayerFrameUI("player") ) then
		print("vehicle");
	elseif ( IsResting() ) then
		print("IsResting");
	elseif ( PlayerFrame.inCombat ) then
		print("inCombat");
	elseif ( PlayerFrame.onHateList ) then
		print("onHateList");
	else
		print("nothing");
	end--]]
	-- Fix bug where regen is disabled by player is not on a hate list
	if (YarkoMods.isRetail and UnitHasVehiclePlayerFrameUI("player")) then
		if (PlayerFrame.onHateList and not UnitThreatSituation("player")) then
			PlayerFrameFlash:Show();
			PlayerFrameFlash:SetVertexColor(1.0, 0.0, 0.0, 1.0);
		end
		if (not PlayerFrame.onHateList) then
			PlayerFrameFlash:Hide();
		end
	end
	
	if ( PlayerFrame.inCombat ) then
		PlayerStatusTexture:SetVertexColor(1.0, 0.0, 0.0, 1.0);
		PlayerStatusTexture:Show();
		if (not YarkoMods.isRetail or not UnitHasVehiclePlayerFrameUI("player") or YarkoMods_SavedVars.Resting == "Y") then
			PlayerAttackIcon:Show();
			PlayerAttackGlow:Show();
		end
		PlayerRestIcon:Hide();
		PlayerRestGlow:Hide();
		PlayerStatusGlow:Show();
		PlayerAttackBackground:Hide();
	elseif ( PlayerFrame.onHateList ) then
		if (not YarkoMods.isRetail or not UnitHasVehiclePlayerFrameUI("player") or YarkoMods_SavedVars.Resting == "Y") then
			PlayerAttackIcon:Show();
		end
		PlayerRestIcon:Hide();
		PlayerStatusGlow:Hide();
		PlayerAttackBackground:Hide();
	end
end

function YarkoMods.PlayerFrameToVehicleArt()
	PlayerFrameFlash:SetPoint("TOPLEFT", 13, 0);
	PlayerFrameFlash:SetHeight(93);
	PlayerFrameFlash:SetWidth(242);
end

function YarkoMods.PlayerFrameToPlayerArt()
	if (YarkoMods_SavedVars.Resting == "Y") then
		PlayerFrameFlash:SetTexture("Interface\\AddOns\\YarkoMods\\Textures\\CombatGlow.tga");
		PlayerFrameFlash:SetPoint("TOPLEFT", 0, 23);
		PlayerFrameFlash:SetHeight(128);
		PlayerFrameFlash:SetWidth(256);
		PlayerFrameFlash:SetTexCoord(1, 0, 0, 1);
	else
		PlayerFrameFlash:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-Flash");
		PlayerFrameFlash:SetPoint("TOPLEFT", 13, 0);
		PlayerFrameFlash:SetHeight(93);
		PlayerFrameFlash:SetWidth(242);
		PlayerFrameFlash:SetTexCoord(0.9453125, 0, 0, 0.181640625);
	end
end

function YarkoMods.UpdatePlayerFrame()
	if (YarkoMods_SavedVars.Resting == "Y") then
		-- Move player rest icon
		PlayerRestIcon:SetPoint("TOPLEFT", PlayerRestIcon:GetParent(),"TOPLEFT", 67, 0);
		PlayerRestGlow:SetPoint("TOPLEFT", -1, -1);
		PlayerAttackIcon:SetTexture("Interface\\AddOns\\YarkoMods\\Textures\\StateIcon.tga");
		PlayerAttackGlow:SetTexture("Interface\\AddOns\\YarkoMods\\Textures\\StateIcon.tga");
		
		if (YarkoMods.isRetail and PlayerFrame.state ~= "vehicle") then
			PlayerFrameFlash:SetTexture("Interface\\AddOns\\YarkoMods\\Textures\\CombatGlow.tga");
			PlayerFrameFlash:SetPoint("TOPLEFT", 0, 23);
			PlayerFrameFlash:SetHeight(128);
			PlayerFrameFlash:SetWidth(256);
			PlayerFrameFlash:SetTexCoord(1, 0, 0, 1);
		end
	else
		-- put it back
		PlayerRestIcon:SetPoint("TOPLEFT", PlayerRestIcon:GetParent(),"TOPLEFT", (YarkoMods.isRetail and 39) or 37, (YarkoMods.isRetail and -50) or -49);
		PlayerRestGlow:SetPoint("TOPLEFT", 0, 0);
		PlayerAttackIcon:SetTexture("Interface\\CharacterFrame\\UI-StateIcon");
		PlayerAttackGlow:SetTexture("Interface\\CharacterFrame\\UI-StateIcon");
		
		if (YarkoMods.isRetail and PlayerFrame.state ~= "vehicle") then
			PlayerFrameFlash:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-Flash");
			PlayerFrameFlash:SetPoint("TOPLEFT", 13, 0);
			PlayerFrameFlash:SetHeight(93);
			PlayerFrameFlash:SetWidth(242);
			PlayerFrameFlash:SetTexCoord(0.9453125, 0, 0, 0.181640625);
		end
	end
	
	if (YarkoMods.isRetail and PlayerFrame.state == "vehicle") then
		PlayerFrame_UpdateStatus();
	end
end

function YarkoMods.TradeSkillDetailUpdate(id, craft)
	local recipeInfo;

	if (YarkoMods.isRetail) then
		recipeInfo = id and C_TradeSkillUI.GetRecipeInfo(id);
	else
		if (craft) then
			recipeInfo = id and GetCraftInfo(id);
		else
			recipeInfo = id and GetTradeSkillInfo(id);
		end
	end
	
	if recipeInfo then
		local maxCreate = 0;
		local minCreate = -1;
		
		local numReagents;

		if (YarkoMods.isRetail) then
			numReagents = C_TradeSkillUI.GetRecipeNumReagents(id);
		else
			if (craft) then
				numReagents = GetCraftNumReagents(id);
			else
				numReagents = GetTradeSkillNumReagents(id);
			end
		end
		
		for reagentIndex = 1, numReagents do
			local reagentCount, playerReagentCount, reagentButton;

			if (YarkoMods.isRetail) then
				_, _, reagentCount, playerReagentCount = C_TradeSkillUI.GetRecipeReagentInfo(id, reagentIndex);
				reagentButton = TradeSkillFrame.DetailsFrame.Contents["Reagent"..reagentIndex];
			else
				if (craft) then
					_, _, reagentCount, playerReagentCount = GetCraftReagentInfo(id, reagentIndex);
					reagentButton = _G["CraftReagent"..reagentIndex];
				else
					_, _, reagentCount, playerReagentCount = GetTradeSkillReagentInfo(id, reagentIndex);
					reagentButton = _G["TradeSkillReagent"..reagentIndex];
				end
			end

			local factor = floor(playerReagentCount / reagentCount);
			
			if (factor > maxCreate) then
				maxCreate = factor;
			end
			
			if (factor < minCreate or minCreate < 0) then
				minCreate = factor;
			end
			
			reagentButton.reagentCount = reagentCount;
			reagentButton.playerReagentCount = playerReagentCount;
			
			if (craft) then
				CraftFrame.maxCreate = maxCreate;
				CraftFrame.minCreate = minCreate;
			else
				TradeSkillFrame.maxCreate = maxCreate;
				TradeSkillFrame.minCreate = minCreate;
			end
		end
	end
end

function YarkoMods.TradeSkillDetailTooltip(button)
	lineAdded = false;
	
	local prc = button.playerReagentCount;
	local rc = button.reagentCount;
	local factor = floor(prc / rc);
	local maxCreate;
	local minCreate;
	
	if (button:GetParent() == CraftDetailScrollChildFrame) then
		maxCreate = CraftFrame.maxCreate;
		minCreate = CraftFrame.minCreate;
	else
		maxCreate = TradeSkillFrame.maxCreate;
		minCreate = TradeSkillFrame.minCreate;
	end

--print("prc: "..prc..", rc: "..rc..", factor: "..factor..", minCreate: "..minCreate..", maxCreate: "..maxCreate);
	
	if (minCreate > 0) then
		YarkoMods.AddTooltipLine("|cff00ff00Can make "..YarkoMods.CommaNumber(minCreate));
	end
	
	if (factor > minCreate) then
		YarkoMods.AddTooltipLine("Would make "..YarkoMods.CommaNumber(factor));
	end
	
	if (factor ~= maxCreate and maxCreate > 1) then
		YarkoMods.AddTooltipLine("|cffff750fNeed "..YarkoMods.CommaNumber((rc * maxCreate) - prc)..((prc > 0 and " more") or "").." to make "..YarkoMods.CommaNumber(maxCreate));
	end
	
	if (prc < rc) then
		YarkoMods.AddTooltipLine("|cffffaaaaNeed "..YarkoMods.CommaNumber(rc - prc)..((prc > 0 and " more") or "").." to make 1");
	end
	
	GameTooltip:Show();
end

function YarkoMods.AddTooltipLine(str)
	if (not lineAdded) then
		GameTooltip:AddLine(" ");
		lineAdded = true;	
	end
	
	GameTooltip:AddLine(str);
end

function YarkoMods.Version()
	local version, build, date, tocversion = GetBuildInfo();
	
	print("Version: "..version..", Build Number: "..build..", Date: "..date..", ToC Version: "..tocversion);
end

function YarkoMods.ClearActionBars()
	for i=1, 120 do
		PickupAction(i);
		PutItemInBackpack();
	end
end

function YarkoMods.DeleteGraysRadioButtonOnClick(arg)
	if (arg == 1) then
		YarkoMods_DeleteGraysFrameRadioButton2:SetChecked(false);
	else
		YarkoMods_DeleteGraysFrameRadioButton1:SetChecked(false);
	end
end

function YarkoMods.DeleteGrays(arg1)
	local slottext = "";
	
	if (string.len(arg1) < 1) then
		print("|cffff0000Parameter required - 'all' or number of bag slots.");
	else
		maxSlots = tonumber(arg1);
		
		if (string.lower(arg1) == "all" or (maxSlots ~= nil and maxSlots >= YarkoMods.CountBagSlots())) then
			maxSlots = 0;
			StaticPopupDialogs["YARKOMODS_DELETEGRAYS"].text = "Delete all gray items from all bag slots?";
		else
			if (maxSlots == nil or maxSlots < 1) then
				print("|cffff0000Invalid bag slot count specified.");
				return;
			else
				if (maxSlots > 1) then
					slottext = "s";
				end
				
				StaticPopupDialogs["YARKOMODS_DELETEGRAYS"].text = "Delete gray items from "..maxSlots.." bag slot"..slottext.."?";
			end
		end
				
		StaticPopup_Show("YARKOMODS_DELETEGRAYS");
	end
end

function YarkoMods.StartDeleteGrays()
	local slottext = "";

	if (not YarkoMods_MainFrame:GetScript("OnUpdate")) then
		if (maxSlots == 0) then
			print("|c0066ff66Attempting to delete all gray items from bags...");
		else
			if (maxSlots > 1) then
				slottext = "s";
			end
			
			print("|c0066ff66Attempting to delete gray items from "..maxSlots.." bag slot"..slottext.."...");
		end
		
		-- find grays and sort by price ascending so we delete the least valuable slots first
		wipe(graysList);
		
		local counter = 1;
		
		for bagId = 0, 4 do
			local numSlots = GetContainerNumSlots(bagId);
			
			if (numSlots > 0) then
				for slotId = 1, numSlots do
					local _, itemCount, _, quality, _, _, itemLink, _, _, itemID = GetContainerItemInfo(bagId, slotId);
					
					if (itemID and quality == 0) then
						graysList[counter] = {};
						graysList[counter].bag = bagId;
						graysList[counter].slot = slotId;
						graysList[counter].itemCount = itemCount;
						graysList[counter].itemLink = itemLink;
						graysList[counter].price = itemCount * select(11, GetItemInfo(itemID));
						
						counter = counter + 1;
					end
				end
			end
		end
		
		if (#graysList > 0) then
			sort(graysList, function(a, b) return a.price < b.price end);
			
			--for i = 1, #graysList do
			--	print(graysList[i].bag, graysList[i].slot,graysList[i].price)
			--end
			curGrayDel = 1;
			delCounter = 0;
			YarkoMods_MainFrame:SetScript("OnUpdate", YarkoMods.DeleteGrayHandler);
		else
			print("|c00ff9900No gray items found to delete");
		end
	else
		print("|cffff0000ERROR: Addon busy. Try again later");
	end
end

function YarkoMods.DeleteGrayHandler()
	if (not CursorHasItem() and not SpellIsTargeting()) then
		PickupContainerItem(graysList[curGrayDel].bag, graysList[curGrayDel].slot);
		DeleteCursorItem();
		
		print("|c00ff9900Deleted "..graysList[curGrayDel].itemLink.."x"..graysList[curGrayDel].itemCount);
		
		delCounter = delCounter + 1;
		curGrayDel = curGrayDel + 1;
	else
		print("|c00ff1919DeleteGrays interrupted by user action.");
		curGrayDel = #graysList + 1;
	end
	
	if (curGrayDel > #graysList or (maxSlots > 0 and delCounter >= maxSlots)) then
		YarkoMods_MainFrame:SetScript("OnUpdate", nil);

		if (delCounter > 0) then
			if (delCounter == 1) then
				slottext = "slot";
			else
				slottext = "slots";
			end
			
			print("|c0066ff66Deleted gray items from "..delCounter.." bag "..slottext);
		end
	end
end

function YarkoMods.DeleteButtonShowTooltip(self)
	GameTooltip:SetOwner(self, "ANCHOR_NONE");
	GameTooltip:SetPoint("TOPRIGHT", self, "BOTTOMRIGHT");
	GameTooltip:AddLine("Destroy Gray Items");
	GameTooltip:Show();
end

function YarkoMods.CountBagSlots()
	local counter = 0;
	local bagId;
	
	for bagId = 0, 4 do
		counter = counter + GetContainerNumSlots(bagId);
	end
	
	return counter;
end

function YarkoMods.StartSellGrays()
	if (not YarkoMods_MainFrame:GetScript("OnUpdate")) then
		print("|c0066ff66Attempting to sell all gray items from bags...");

		curBagId = 0;
		curSlot = 1;
		delCounter = 0;
		selling = false;
		sellTotal = 0;
		sellTimer = GetTime();
		YarkoMods_MainFrame:SetScript("OnUpdate", YarkoMods.SellGraysHandler);
	else
		print("|cffff0000ERROR: Addon busy. Try again later");
	end
end

function YarkoMods.SellGraysHandler()
	if (CursorHasItem() or SpellIsTargeting() or not MerchantFrame:IsShown() or MerchantFrame.selectedTab ~= 1) then
		print("|c00ff1919SellGrays interrupted by user action.");
		curBagId = 5;
	end

	if (GetBagName(curBagId) and curSlot <= GetContainerNumSlots(curBagId)) then
		local itemLink = GetContainerItemLink(curBagId, curSlot);
		
		if (itemLink and not selling) then
			local _, _, itemRarity, _, _, _, _, _, _, _, itemSellPrice = GetItemInfo(itemLink); 
			
			if (itemRarity == 0) then
				local _, itemCount = GetContainerItemInfo(curBagId, curSlot);
				--PickupContainerItem(curBagId, curSlot);
				--DeleteCursorItem();
				UseContainerItem(curBagId, curSlot);
				selling = true;
				sellTimer = GetTime();
				print("|c00ff9900Sold "..itemLink.."x"..itemCount.." ("..GetCoinText(itemSellPrice * itemCount)..")");
				sellTotal = sellTotal + itemSellPrice * itemCount;
				
				delCounter = delCounter + 1;
			end
		end
		
		if ((not itemLink or GetTime() - sellTimer > .3) and selling) then
			selling = false;
		end
		
		if (not selling) then
			curSlot = curSlot + 1;
		end
	else
		curBagId = curBagId + 1;
		curSlot = 1;
	end
	
	if (curBagId > 4) then
		YarkoMods_MainFrame:SetScript("OnUpdate", nil);

		if (delCounter > 0) then
			if (delCounter == 1) then
				slottext = "slot";
			else
				slottext = "slots";
			end
			
			print("|c0066ff66Sold gray items from "..delCounter.." bag "..slottext..": |c00ffff00"..GetCoinText(sellTotal));
		else
			print("|c00ff9900No gray items found to delete");
		end
	end
end

function YarkoMods.SellGraysButtonUpdate()
	if (YarkoMods_SavedVars.Grays ~= "Y") then
		return;
	end
	
	local sellEnable = false;
	local deleteEnable = false;
	
	local quality, noValue;
	
	for curBagId = 0, 4 do
		if (GetBagName(curBagId)) then
			for curSlot = 1, GetContainerNumSlots(curBagId) do
				_, _, _, quality, _, _, _, _, noValue = GetContainerItemInfo(curBagId, curSlot);
				
				if (quality == 0) then
					deleteEnable = true;
					 
					if (not noValue) then
						 sellEnable = true;
						 break;
					end
				end
			end
		end
		
		if (sellEnable) then
			break;
		end
	end
	
	if (MerchantFrame:IsShown() and MerchantFrame.selectedTab == 1 and sellEnable) then
		YarkoMods_SellGraysButton:Enable();
	else
		YarkoMods_SellGraysButton:Disable();
	end
	
	if (deleteEnable) then
		YarkoMods_DeleteGraysButton:Enable();
	else
		YarkoMods_DeleteGraysButton:Disable();
	end
end

function YarkoMods.SellGraysShowTooltip(self)
	GameTooltip:SetOwner(self, "ANCHOR_NONE");
	GameTooltip:SetPoint("TOPRIGHT", self, "BOTTOMRIGHT");
	GameTooltip:AddLine("Sell Gray Items");
	GameTooltip:Show();
end

function YarkoMods.UpdateBackpackTexture(frame, size, id)
	if (YarkoMods_SavedVars.Grays ~= "Y" and (YarkoMods.isRetail or YarkoMods_SavedVars.Search ~= "Y")) then
		-- move extra bag slot notification back up
		if (id == 0 and YarkoMods.isRetail and size > BACKPACK_BASE_SIZE) then
			frame.ExtraBagSlotsHelpBox:SetPoint("TOPRIGHT", frame, "TOPLEFT", -2, -198);
		end
		
		return;
	end
	
	if ( id == 0 ) then
		local name = frame:GetName();
		local bgTextureTop = _G[name.."BackgroundTop"];
		
		local columns = NUM_CONTAINER_COLUMNS;
		local extended = size > BACKPACK_BASE_SIZE;
		local extraRows = 0;
		
		bgTextureTop:SetTexture("Interface\\AddOns\\YarkoMods\\Textures\\BackpackBackground.tga");

		if (YarkoMods.isRetail) then
			if (extended) then
				bgTextureTop:SetHeight(BACKPACK_EXTENDED_TOPHEIGHT + backpackExtraHeight);
				bgTextureTop:SetTexCoord(0, 1, 0, (BACKPACK_EXTENDED_TOPHEIGHT + backpackExtraHeight) / (BACKPACK_DEFAULT_TOPHEIGHT * 2));
				extraRows = math.ceil((size - BACKPACK_BASE_SIZE) / columns);
				
				-- move extra bag slot notification down
				frame.ExtraBagSlotsHelpBox:SetPoint("TOPRIGHT", frame, "TOPLEFT", -2, -233);
			else
				bgTextureTop:SetHeight(BACKPACK_DEFAULT_TOPHEIGHT + backpackExtraHeight);
				bgTextureTop:SetTexCoord(0, 1, 0, (BACKPACK_DEFAULT_TOPHEIGHT + backpackExtraHeight) / (BACKPACK_DEFAULT_TOPHEIGHT * 2));
			end
			
			itemButton = _G[name.."Item1"];
			local point, relativeTo, relativePoint, xOfs, yOfs = itemButton:GetPoint(1);
			itemButton:SetPoint(point, relativeTo, relativePoint, xOfs, yOfs - backpackExtraHeight);
		else
			bgTextureTop:SetHeight(classicBackpackTopHeight + backpackExtraHeight);
			bgTextureTop:SetTexCoord(0, 1, 0, (classicBackpackTopHeight + backpackExtraHeight) / (BACKPACK_DEFAULT_TOPHEIGHT * 2));
			
			local bgTextureBottom = _G[name.."BackgroundBottom"];
			bgTextureBottom:ClearAllPoints();
			bgTextureBottom:SetTexture("Interface\\ContainerFrame\\UI-BackpackBackground");
			bgTextureBottom:SetPoint("TOP", bgTextureTop:GetName(), "BOTTOM", 0, 0);
			bgTextureBottom:SetHeight(BACKPACK_DEFAULT_TOPHEIGHT - classicBackpackTopHeight);
			bgTextureBottom:SetTexCoord(0, 1, classicBackpackTopHeight / BACKPACK_DEFAULT_TOPHEIGHT, 1);
			bgTextureBottom:Show();
		end
		
		_G[name.."MoneyFrame"]:SetPoint("TOPRIGHT", frame, "TOPRIGHT", -2, BACKPACK_MONEY_OFFSET_DEFAULT - backpackExtraHeight
			- (BACKPACK_MONEY_HEIGHT_OFFSET_PER_EXTRA_ROW * extraRows));
	end
end

function YarkoMods.ManageBackpackTokenFrame(backpack)
	if ( not backpack ) then
		backpack = GetBackpackFrame();
	end
	if ( not backpack ) then
		return;
	end
	if ( BackpackTokenFrame_IsShown() ) then
		backpack:SetHeight(BACKPACK_HEIGHT+BACKPACK_TOKENFRAME_HEIGHT+backpackExtraHeight);
	else
		backpack:SetHeight(BACKPACK_HEIGHT+backpackExtraHeight);
	end
end

function YarkoMods.ContainerFrameUpdate(frame)
	if (YarkoMods_SavedVars.Grays ~= "Y" and (YarkoMods.isRetail or YarkoMods_SavedVars.Search ~= "Y")) then
		return;
	end
	
	local id = frame:GetID();
	
	if ( id == 0 ) then
		if (YarkoMods.isRetail) then
			BagItemSearchBox:SetPoint("TOPLEFT", frame, "TOPLEFT", 25, -73);
			BagItemAutoSortButton:SetPoint("TOPRIGHT", frame, "TOPRIGHT", -13, -69);
		end
		
		if (YarkoMods_SavedVars.Grays == "Y") then
			YarkoMods_SellGraysButton.anchorBag = frame;
			YarkoMods_SellGraysButton:SetParent(frame);
			YarkoMods_SellGraysButton:SetPoint("TOPLEFT", frame, "TOPLEFT", 47, -37);
			YarkoMods_SellGraysButton:Show();
			YarkoMods_DeleteGraysButton:SetParent(frame);
			YarkoMods_DeleteGraysButton:Show();
		end
	elseif ( YarkoMods_SellGraysButton.anchorBag == frame ) then
		YarkoMods_SellGraysButton.anchorBag = nil;
		YarkoMods_SellGraysButton:ClearAllPoints();
		YarkoMods_SellGraysButton:Hide();
		YarkoMods_DeleteGraysButton:Hide();
	end
	
	if (not YarkoMods.isRetail) then
		if ( id == 0 ) then
			if (YarkoMods_SavedVars.Search == "Y") then
				YarkoMods_BagSearchBox:SetParent(frame);
				YarkoMods_BagSearchBox:SetPoint("TOPLEFT", frame, "TOPLEFT",  (YarkoMods_SavedVars.Grays == "Y" and 28) or 56, (YarkoMods_SavedVars.Grays == "Y" and -73) or -37);
				YarkoMods_BagSearchBox.anchorBag = frame;
				YarkoMods_BagSearchBox:Show();
			end
		elseif ( YarkoMods_BagSearchBox.anchorBag == frame ) then
			YarkoMods_BagSearchBox:ClearAllPoints();
			YarkoMods_BagSearchBox:Hide();
			YarkoMods_BagSearchBox.anchorBag = nil;
		end
	end
end

function YarkoMods.UpdateBagState()
	if (YarkoMods_SavedVars.Grays == "Y" or (not YarkoMods.isRetail and YarkoMods_SavedVars.Search == "Y")) then
		if (YarkoMods.isRetail) then
			backpackExtraHeight = retailBackpackExtraHeight;
		elseif (YarkoMods_SavedVars.Grays ~= "Y") then
			backpackExtraHeight = classicBackpackExtraHeight1;
		elseif (YarkoMods_SavedVars.Search ~= "Y") then
			backpackExtraHeight = classicBackpackExtraHeight2;
		else
			backpackExtraHeight = classicBackpackExtraHeight3;
		end
		
		-- made local in retail so i cant adjust these in retail
		if (not YarkoMods.isRetail) then
			BACKPACK_BASE_HEIGHT = origBackpackBaseHeight + backpackExtraHeight;
			FIRST_BACKPACK_BUTTON_OFFSET_BASE = origFirstBackpackButtonOffsetBase - backpackExtraHeight;
		end
	else
		backpackExtraHeight = 0;
		
		if (not YarkoMods.isRetail) then
			BACKPACK_BASE_HEIGHT = origBackpackBaseHeight;
			FIRST_BACKPACK_BUTTON_OFFSET_BASE = origFirstBackpackButtonOffsetBase;
		end
	end
	
	if (YarkoMods_SavedVars.Grays ~= "Y") then
		YarkoMods_SellGraysButton:Hide();
		YarkoMods_DeleteGraysButton:Hide();
	end
	
	if (YarkoMods_SavedVars.Search ~= "Y") then
		YarkoMods_BagSearchBox:Hide();
	end
	
	if (YarkoMods.isRetail) then
		if (YarkoMods_SavedVars.Grays == "Y") then
			BagItemSearchBox:SetWidth(124);
			ContainerFrame1AddSlotsButton:ClearAllPoints();
			ContainerFrame1AddSlotsButton:SetPoint("TOPLEFT", 5, -254);
		else
			BagItemSearchBox:SetWidth(96);
			ContainerFrame1AddSlotsButton:ClearAllPoints();
			ContainerFrame1AddSlotsButton:SetPoint("TOP", ContainerFrame1AddSlotsButton:GetParent(), "TOPLEFT", 17, -224);
		end
	end
	
	-- Move bank title text over to make room for search box
	if (not YarkoMods.isRetail) then
		if (YarkoMods_SavedVars.Search == "Y") then
			YarkoMods_BankSearchBox:Show();
			select(4,BankFrame:GetRegions()):SetPoint("CENTER", -55, 194);
		else
			YarkoMods_BankSearchBox:Hide();
			select(4,BankFrame:GetRegions()):SetPoint("CENTER", -10, 194);
		end
		
		if (YarkoMods_SavedVars.Grays == "Y") then
			YarkoMods_BagSearchBox:SetWidth(145);
		else
			YarkoMods_BagSearchBox:SetWidth(117);
		end
	end
end

function YarkoMods.MinimapOnMouseWheel(self, direction)
	if (direction > 0) then
		MinimapZoomIn:Click();
	else
		MinimapZoomOut:Click();
	end
end

local function AddDateToTooltip()
	GameTooltip:AddLine(date("%A"), HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	GameTooltip:AddLine(date("%B %e, %Y"), HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	GameTooltip:AddLine(" ");
end

function YarkoMods.CalendarTooltip(self)
	if ( GameTooltip:IsOwned(self) ) then
		GameTooltip:ClearLines();
		
		AddDateToTooltip();
		
		if ( GameTimeCalendarInvitesTexture:IsShown() ) then
			GameTooltip:AddLine(GAMETIME_TOOLTIP_CALENDAR_INVITES);
			if ( CalendarFrame and not CalendarFrame:IsShown() ) then
				GameTooltip:AddLine(" ");
				GameTooltip:AddLine(GAMETIME_TOOLTIP_TOGGLE_CALENDAR);
			end
		else
			if ( not TimeManagerClockButton or not TimeManagerClockButton:IsVisible() or TimeManager_IsAlarmFiring() ) then
				GameTooltip:AddLine(GameTime_GetGameTime(true), HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
				GameTooltip:AddLine(" ");
			end
			GameTooltip:AddLine(GAMETIME_TOOLTIP_TOGGLE_CALENDAR);
		end
		
		GameTooltip:Show();
	end
end

-- from TimeManagerClockButton_UpdateTooltip in Blizzard_TimeManager.lua
local Settings = {
	militaryTime = false;
	localTime = false;

	alarmHour = 12;
	alarmMinute = 00;
	alarmAM = true;
	alarmMessage = "";
	alarmEnabled = false;
};

function YarkoMods.TimeTooltip()
	GameTooltip:ClearLines();

	if ( TimeManagerClockButton.alarmFiring ) then
		if ( gsub(Settings.alarmMessage, "%s", "") ~= "" ) then
			GameTooltip:AddLine(Settings.alarmMessage, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b, true);
			GameTooltip:AddLine(" ");
		end
		GameTooltip:AddLine(TIMEMANAGER_ALARM_TOOLTIP_TURN_OFF);
	else
		GameTime_UpdateTooltip();
		GameTooltip:AddLine(" ");
		AddDateToTooltip();
		GameTooltip:AddLine(GAMETIME_TOOLTIP_TOGGLE_CLOCK);
	end

	-- readjust tooltip size
	GameTooltip:Show();
end

function YarkoMods.AdjustGamma(value)
	local min, max = Advanced_GammaSlider:GetMinMaxValues();
	local valueStep = Advanced_GammaSlider:GetValueStep();
	local curGamma = tonumber(GetCVar("Gamma"));
	
	if (value == "UP") then
		if (curGamma < max) then
			local newVal = curGamma + valueStep;
			BlizzardOptionsPanel_SetCVarSafe("Gamma", newVal);
			print(YELLOW_FONT_COLOR_CODE.."Gamma increased to "..format("%.1f", newVal));
		end
	else
		if (curGamma > min) then
			local newVal = curGamma - valueStep;
			BlizzardOptionsPanel_SetCVarSafe("Gamma", newVal);
			print(YELLOW_FONT_COLOR_CODE.."Gamma dencreased to "..format("%.1f", newVal));
		end
	end
end

function YarkoMods.OpenBankBags() 
	for i=NUM_BAG_SLOTS+1, (NUM_BAG_SLOTS + NUM_BANKBAGSLOTS), 1 do
		OpenBag(i);
	end
end

function YarkoMods.StartOpenClams(bagId)
	if (YarkoMods_SavedVars.Clams ~= "Y" or not GetCVarBool("autoLootDefault")) then
		return;
	end
	
	tinsert(shellQueue, bagId);
	
	if (not shellRunning) then
		if (YarkoMods_MainFrame:GetScript("OnUpdate")) then
			--print("|cffff0000ERROR: Addon busy. Unable to open clam shells.");
			return;
		end
		
		curBagId = -1;
		shellRunning = true;
		
		YarkoMods_MainFrame:SetScript("OnUpdate", YarkoMods.OpenClamsHandler);
	end
end

function YarkoMods.OpenClamsHandler(self, elapsed)
	if (curBagId < 0 and #shellQueue > 0) then
		-- start new bag
		curBagId = shellQueue[1];
		tremove(shellQueue, 1);
		curSlot = 1;
		shellSlot = 0;
		shellOpening = false;
		shellTime = 0;
	end
	
	while (curSlot <= GetContainerNumSlots(curBagId)) do
		local itemLink = select(7, GetContainerItemInfo(curBagId, curSlot));
		
		if (itemLink) then
			local name = strsub(itemLink, strfind(itemLink, "%[") + 1, strfind(itemLink, "]") - 1);
			
			if (shellList[name]) then
				shellSlot = curSlot;
			end
		end
		
		curSlot = curSlot + 1;
	end
	
	if (shellSlot > 0) then
		if (not shellOpening) then
			UseContainerItem(curBagId, shellSlot);
			shellOpening = true;
			shellTime = 0;
		else
			shellTime = shellTime + elapsed;
			
			local found = false;
			local itemLink = select(7, GetContainerItemInfo(curBagId, shellSlot));
			
			if (itemLink) then
				local name = strsub(itemLink, strfind(itemLink, "%[") + 1, strfind(itemLink, "]") - 1);
				
				if (shellList[name]) then
					found = true;
				end
			end
			
			if (not found) then
				curSlot = shellSlot + 1;
				shellSlot = 0;
				shellOpening = false;
				shellTime = 0;
			end
		end
	else
		-- done with bag
		curBagId = -1;
	end
	
	if ((shellSlot == 0 and curBagId < 0 and #shellQueue < 1) or shellTime > 3) then
		YarkoMods_MainFrame:SetScript("OnUpdate", nil);
		shellRunning = false;
		
		-- if (shellTime > 3) then
			-- print("|cffff0000ERROR: Unable to open clam shell.");
		-- end
	end
end

function YarkoMods.TradeSkillSetSelection(id)
	local numReagents = GetTradeSkillNumReagents(id);
	for i=1, numReagents, 1 do
		local reagentName, reagentTexture, reagentCount, playerReagentCount = GetTradeSkillReagentInfo(id, i);
		local count = getglobal("TradeSkillReagent"..i.."Count");
		if ( reagentName and reagentTexture ) then
			local str = " /";
			if ( (reagentCount > 9 and playerReagentCount > 9) or playerReagentCount > 99 ) then
				str = "|n/";
			end
			playerReagentCount = AbbreviateNumbers(playerReagentCount);
			-- save manual way for posterity :)
			-- if (playerReagentCount > 999) then
				-- local fixedCount = playerReagentCount + 50;
				-- local decimal = floor(((mod(fixedCount, 1000))/100));
				-- playerReagentCount = floor((fixedCount)/1000)..(decimal > 0 and ("."..decimal) or "").."K"
			-- end
			count:SetText(playerReagentCount..str..reagentCount);
		end
	end
end

function YarkoMods.ChatFrameOnEvent(self, event, ...)
	local arg1 = ...;
	
	-- block chat chennel invite text completely
	if (event == "CHAT_MSG_CHANNEL_NOTICE_USER" and arg1 == "INVITE" and GetCVarBool("blockChannelInvites")) then
		return;
	end
	
	origChatFrameOnEvent(self, event, ...);
end

function YarkoMods.CommaNumber(num)
  assert (num);
  
  local result = "";
  local sign, before, after = strmatch(tostring(num), "^([%+%-]?)(%d*)(%.?.*)$");

  while strlen(before) > 3 do
    result = ","..strsub(before, -3, -1)..result;
    before = strsub(before, 1, -4);
  end

  return sign..before..result..after
end

function YarkoMods.PlaySound(arg1)
	if (arg1) then
		if (string.len(arg1) > 0 and not string.find(arg1, " ")) then
			local soundfile = soundsDir..string.lower(arg1)..".mp3";
			PlaySoundFile(soundfile);
			--retval = PlaySoundFile(soundfile);
					
			--if (not retval) then
			--	print("|c00ff0000Attempted to play sound file \""..soundfile
			--		.."\", but the file does not exist or is invalid.");
			--end
		else
			print("|c00ff0000Invalid sound file name.");
		end
	end
end

