
---------------------------------------------------
-- Global vars
---------------------------------------------------
YarkoMods.defaults = {};
YarkoMods.defaults.CombatSounds = "Y";
YarkoMods.defaults.Resting = "Y";
YarkoMods.defaults.BarInfo = "Y";
YarkoMods.defaults.Coords = "Y";
YarkoMods.defaults.MapCoords = "Y";
YarkoMods.defaults.Auction = "Y";
YarkoMods.defaults.Grays = "Y";
YarkoMods.defaults.Search = "Y";
YarkoMods.defaults.Clams = "Y";
YarkoMods.defaults.Roster = "Y";
YarkoMods.defaults.Location = {point = "TOPRIGHT", relativeTo = "UIParent", relativePoint = "TOPRIGHT", xOfs = -32, yOfs = -175};

---------------------------------------------------
-- YarkoMods.SetupOptions
---------------------------------------------------
function YarkoMods.SetupOptions()
	if (not YarkoMods_SavedVars) then
		YarkoMods_SavedVars = {};
	end
	
	for k,v in pairs(YarkoMods.defaults) do
		if (not YarkoMods_SavedVars[k]) then
			YarkoMods_SavedVars[k] = v;
		end
	end
	
	InterfaceOptions_AddCategory(YarkoMods_OptionsPanel);
	
	if (YarkoMods.isRetail) then
		YarkoMods_OptionsPanelSearch:Hide();
		YarkoMods_OptionsPanelClams:Hide();
		YarkoMods_OptionsPanelRoster:Hide();
	end
	
	YarkoMods.UpdateInterface();
end


---------------------------------------------------
-- YarkoMods.OptionsDefault
---------------------------------------------------
function YarkoMods.OptionsDefault()
	for k,v in pairs(YarkoMods.defaults) do
		YarkoMods_SavedVars[k] = v;
	end
	
	YarkoMods.UpdateInterface();
end


---------------------------------------------------
-- YarkoMods.OptionsRefresh
---------------------------------------------------
function YarkoMods.OptionsRefresh(self)
	YarkoMods_OptionsPanelCombatSounds:SetChecked(YarkoMods_SavedVars.CombatSounds == "Y");
	YarkoMods_OptionsPanelResting:SetChecked(YarkoMods_SavedVars.Resting == "Y");
	YarkoMods_OptionsPanelBarInfo:SetChecked(YarkoMods_SavedVars.BarInfo == "Y");
	YarkoMods_OptionsPanelCoords:SetChecked(YarkoMods_SavedVars.Coords == "Y");
	YarkoMods_OptionsPanelMapCoords:SetChecked(YarkoMods_SavedVars.MapCoords == "Y");
	YarkoMods_OptionsPanelAuction:SetChecked(YarkoMods_SavedVars.Auction == "Y");
	YarkoMods_OptionsPanelGrays:SetChecked(YarkoMods_SavedVars.Grays == "Y");
	YarkoMods_OptionsPanelSearch:SetChecked(YarkoMods_SavedVars.Search == "Y");
	YarkoMods_OptionsPanelClams:SetChecked(YarkoMods_SavedVars.Clams == "Y");
	YarkoMods_OptionsPanelRoster:SetChecked(YarkoMods_SavedVars.Roster == "Y");
end


---------------------------------------------------
-- YarkoMods.OptionsOkay
---------------------------------------------------
function YarkoMods.OptionsOkay()
	YarkoMods_SavedVars.CombatSounds = ((YarkoMods_OptionsPanelCombatSounds:GetChecked() and "Y") or "N");
	YarkoMods_SavedVars.Resting = ((YarkoMods_OptionsPanelResting:GetChecked() and "Y") or "N");
	YarkoMods_SavedVars.BarInfo = ((YarkoMods_OptionsPanelBarInfo:GetChecked() and "Y") or "N");
	YarkoMods_SavedVars.Coords = ((YarkoMods_OptionsPanelCoords:GetChecked() and "Y") or "N");
	YarkoMods_SavedVars.MapCoords = ((YarkoMods_OptionsPanelMapCoords:GetChecked() and "Y") or "N");
	YarkoMods_SavedVars.Auction = ((YarkoMods_OptionsPanelAuction:GetChecked() and "Y") or "N");
	YarkoMods_SavedVars.Grays = ((YarkoMods_OptionsPanelGrays:GetChecked() and "Y") or "N");
	YarkoMods_SavedVars.Search = ((YarkoMods_OptionsPanelSearch:GetChecked() and "Y") or "N");
	YarkoMods_SavedVars.Clams = ((YarkoMods_OptionsPanelClams:GetChecked() and "Y") or "N");
	YarkoMods_SavedVars.Roster = ((YarkoMods_OptionsPanelRoster:GetChecked() and "Y") or "N");
	
	YarkoMods.UpdateInterface();
end


---------------------------------------------------
-- YarkoMods.UpdateInterface
---------------------------------------------------
function YarkoMods.UpdateInterface()
	if (YarkoMods_SavedVars.CombatSounds == "Y" and not YarkoMods_MainFrame:IsEventRegistered("PLAYER_REGEN_DISABLED")) then
		YarkoMods_MainFrame:RegisterEvent("PLAYER_REGEN_DISABLED");
		YarkoMods_MainFrame:RegisterEvent("PLAYER_REGEN_ENABLED");
	end
	
	if (YarkoMods_SavedVars.CombatSounds ~= "Y" and YarkoMods_MainFrame:IsEventRegistered("PLAYER_REGEN_DISABLED")) then
		YarkoMods_MainFrame:UnregisterEvent("PLAYER_REGEN_DISABLED");
		YarkoMods_MainFrame:UnregisterEvent("PLAYER_REGEN_ENABLED");
	end
	
	if (YarkoMods_SavedVars.Coords == "Y") then
		YarkoMods_PlayerLocFrame:Show();
	else
		YarkoMods_PlayerLocFrame:Hide();
	end
	
	if (YarkoMods_SavedVars.MapCoords == "Y") then
		YarkoMods_MapLocFrame:Show();
	else
		YarkoMods_MapLocFrame:Hide();
	end
	
	YarkoMods_PlayerLocFrame:ClearAllPoints();
	YarkoMods_PlayerLocFrame:SetPoint(YarkoMods_SavedVars.Location.point, YarkoMods_SavedVars.Location.relativeTo, YarkoMods_SavedVars.Location.relativePoint,
		YarkoMods_SavedVars.Location.xOfs, YarkoMods_SavedVars.Location.yOfs)
	
	YarkoMods.UpdatePlayerFrame();
	YarkoMods.UpdateBagState();
	
	-- don't run until after player entered world
	if (YarkoMods.initialized) then
		YarkoMods.UpdateExpBars();
	end
end
